﻿Type=Class
Version=4
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(SourceDir As String,SourceFile As String,TargetDir As String,TargetFile As String)
	
	'Need to work with a temp file as otherwise it cannot be played with an external app until this app is closed.
	Dim TempDir As String = File.DirTemp
	Dim TempFile As String = "TempFile999.flac"
	
	'Copy the source file if it is the assets directory
	Dim FileCopied As Boolean
	If SourceDir = File.DirAssets Then
		File.Copy(SourceDir,SourceFile,File.DirTemp,SourceFile)
		SourceDir = File.DirTemp
		FileCopied = True
	End If
	
	Dim FlacEncoder,inFile,outFile As JavaObject
	FlacEncoder.InitializeNewInstance("javaFlacEncoder.FLAC_FileEncoder",Null)
	inFile.InitializeNewInstance("java.io.File",Array(SourceDir,SourceFile))
	outFile.InitializeNewInstance("java.io.File",Array(TempDir,TempFile))
	
	Log(FlacEncoder.RunMethod("encode",Array(inFile,outFile)))
	
	'Remove the copied file if needed
	If FileCopied Then
		File.Delete(SourceFile,SourceFile)
	End If
	
	'Copy the temp file to it's required location
	File.Copy(TempDir,TempFile,TargetDir,TargetFile)
	
	'Remove the temp file
	File.Delete(TempDir,TempFile)
	
	Log("File " & TargetFile & " saved to " & TargetDir)
End Sub